<template>
  <!-- desktop -->
  <!-- <v-row v-if="!isMobile()"> -->
  <v-row>
    <v-col lg="12">
      <v-tabs
        v-model="tab"
        show-arrows
        background-color="grey pa-0 ma-0"
        class="pl-0"
        dark
        grow
        active-class="teal darken-3"
        slider-color="blue"
        :scrollable="false"
        @change="onTabChange"
      >
        <!-- <v-tabs-slider color="cyan darken-4"></v-tabs-slider> -->
        <v-tab
          v-for="(tab, idx) in tabs"
          :key="tab.index"
          :disabled="tab.disabled"
          ripple
          :class="tab.color"
        >
          <v-icon small>
            {{ tab.icon }}
          </v-icon>
          <div class="caption py-1 pa-0 ma-0">
            {{ tab.name }}
          </div>
        </v-tab>
        <v-tabs-items
          v-model="tab"
          touchless
          class=" pa-0 ma-0"
        >
          <!-- TỔNG -->
          <v-tab-item class="tab-item">
            <v-data-table
              v-model="selected"
              :headers="headers"
              :items="chiTieuList"
              :single-select="singleSelect"
              :search="search"
              class="elevation-1 table-list"
              show-select
              fixed-header
              height="510"
            >
              <!-- Search -->
              <template v-slot:top>
                <v-row class="ma-0 pa-0">
                  <v-col
                    cols="12"
                    lg="6"
                    class="d-lg-inline-flex mb-1 pa-0"
                  >
                    <v-checkbox
                      v-model="bankChecked"
                      value="HSBC"
                      label="HSBC"
                      color="red"
                      class="pa-0 ma-0 ml-3 mt-3"
                      hide-details
                      @change="filterStatus()"
                    />
                    <v-checkbox
                      v-model="bankChecked"
                      label="SC BANK"
                      value="SC BANK"
                      color="red"
                      class="pa-0 ma-0 ml-3 mt-3"
                      hide-details
                      @change="filterStatus()"
                    />
                    <v-checkbox
                      v-model="bankChecked"
                      label="CITI BANK"
                      value="CITI BANK"
                      color="red"
                      class="pa-0 ma-0 ml-3 mt-3"
                      hide-details
                      @change="filterStatus()"
                    />
                  </v-col>
                  <v-col
                    cols="12"
                    lg="6"
                    class="ma-0 pa-0 pl-3 text-right mb-1"
                  >
                    <v-text-field
                      v-model="search"
                      label="Tìm kiếm"
                      class="pa-0 ma-0 ml-3 mt-2 mr-4"
                      hide-details=""
                    />
                  </v-col>
                </v-row>
              </template>
              <!-- body -->
              <template v-slot:item.noi_dung="{ item }">
                <router-link
                  v-slot="{ href, route, navigate, isActive, isExactActive }"
                  :to="{ name: 'CHI TIET SAN PHAM', params: { id: item.id } }"
                >
                  <a
                    :href="href"
                    @click="navigate"
                  >{{ item.noi_dung }}</a>
                </router-link>
              </template>

              <template v-slot:item.so_tien="{ item }">
                {{ formatPrice(item.so_tien, 2) }}
              </template>

              <template v-slot:item.ngay_chi="{ item }">
                {{ moment(String(item.ngay_chi)).format("DD/MM/YYYY hh:mm") }}
                <!-- {{  item.ngay_chi | moment }} -->
              </template>

              <template v-slot:item.status_nm="{ item }">
                <span :style="item.status_nm == 'FAIL'||item.status_nm == 'NX' ? 'color: #FF0000' : ''">
                  {{ stsThanhToan.filter(sts => sts.id == item.status_nm).pop().name }}
                </span>
                <!-- {{  item.ngay_chi | moment }} -->
              </template>

              <template v-slot:item.muc_dich="{ item }">
                {{
                  lstMucDich.filter(sts => sts.id === item.muc_dich).pop().name
                }}
                <!-- {{  item.ngay_chi | moment }} -->
              </template>

              <template v-slot:item.balance_in_month="{ item }">
                {{ formatPrice(item.balance_in_month, 2) }}
              </template>
            </v-data-table>
          </v-tab-item>
        </v-tabs-items>
      </v-tabs>
    </v-col>
    <v-col class="mt-0 pt-1" />
    <!-- </v-row> -->
    <!-- end desktop -->

    <!-- mobile-->

    <!-- end mobile-->
    <!-- <v-row>
      <addProduct
        ref="addProductDialog"
        :v-model="dialog"
        @refeshList="getChiTieus"
      />
    </v-row>
    <v-row>
      <addChiTieu
        ref="addChiTieu"
        :v-model="dialogChiTieu"
        @refeshList="getChiTieus"
      />
    </v-row>

    <v-row>
      <updateStatus
        ref="refUpdateStatus"
        :v-model="dialogChiTieu"
        @refeshList="getChiTieus"
      />
    </v-row>

    <v-row>
      <dialogConfirm
        ref="dialogConfirm"
        :v-model="dialogConfirm"
        :title="titleConfirm"
        :content="contentConfirm"
        @select-ok="deleteChiTieu()"
      />
    </v-row> -->

    <!-- <v-row>
      <dialogAlert
        ref="dialogAlert"
        :v-model="dialogAlert"
      />
    </v-row> -->

    <!-- <v-row>
      <snackbarNew
        ref="snackNotification"
        :v-model="snackbar"
      />
    </v-row> -->

    <!-- <v-row>
      <chiTieuTotal
        ref="chiTieuTotal"
        :v-model="chiTieuTotalDialog"
      />
    </v-row> -->
    <!-- <v-row>
      <addChiTieu
        ref="addChiTieu"
        :v-model="dialogChiTieu"
        @refeshList="getChiTieus()"
      />
    </v-row> -->
  </v-row>
</template>

<script>
  import axios from 'axios'
  import moment from 'moment'
  // import { NumericInput } from 'numeric-keyboard'
  import config from '@/config/config'
  // import addProduct from '../sales/add-product'
  // import addChiTieu from '../kinhte/add-chitieu'
  // import chiTieuTotal from '../kinhte/chi-tieu-total'
  // import updateStatus from '../kinhte/update-status-chitieu'

  // import dialogConfirm from '../dashboard/component/dialogConfirm'
  // import dialogAlert from '../dashboard/component/dialogAlert'
  // import snackbarNew from '../dashboard/component/snackbarNew'
  // import orderDetail from '../sales/sale-order-detail'

  export default {
    layout: 'SaleStorage',
    components: {
      // materialCard,
      // ProgressBar,
      // addProduct,
      // addChiTieu,
      // dialogConfirm,
      // dialogAlert,
      // snackbarNew,
      // orderDetail,
      // chiTieuTotal,
      // updateStatus,
      // NumericInput,
    // VueEllipseProgress
    },
    filters: {
      moment: function (date) {
        return moment(date).format('MMMM Do YYYY, h:mm:ss a')
      },
    },
    props: {
      // change the layout of keyboard
      layout: {
        type: [String, Array],
        default: 'number',
      },
      // change the label of keyboard enter key, use iconfont for icon.
      entertext: {
        type: String,
        default: 'enter',
      },
    },
    data () {
      return {
        // Tab
        tab: null,
        tab_confirm_disabled: true,
        tabs: [
          { name: 'Tổng', index: 0 },
          { name: 'Chờ thanh toán', index: 1 },
          { name: 'Chờ sao kê', index: 2 },
          { name: 'Dự chi', index: 3 },
          { name: 'Giao dịch lỗi', color: 'error', index: 4 },
        ],
        search: '',
        amount: '',
        dialog: false,
        singleSelect: false,
        selected: [],
        dialogStatus: false,
        dialogChiTieu: false,
        dialogConfirm: false,
        dialogAlert: false,
        chiTieuTotalDialog: false,
        pageCount: 0,
        itemPerPage: 5,
        bankList: [],
        kyChiSeleted: [],
        bankSeleted: [],
        statusSeleted: [],
        bankChecked: ['HSBC', 'SC BANK', 'CITI BANK'],
        chiTieuList: [],
        chiTieuCSKList: [], // Cho sao ke
        chiTieuCTTList: [], // Cho Thanh toan
        chiTieuDCList: [], // Du Chi
        chiTieuErList: [], // GD Loi
        order_customer_type: 'KL',
        knowledge: 30,
        orderDetail: false,
        show: false,
        color: null,
        colors: ['purple', 'info', 'success', 'warning', 'error'],
        top: true,
        bottom: false,
        left: false,
        right: false,
        snackbar: false,
        titleConfirm: 'Xác nhận',
        contentConfirm: 'Bạn có chắc chắn muốn xóa đơn hàng này không?',
        filterArr: [],
        saleOrder: {
          order_customer_type: 'KL',
        },
        customerTypeModal: {
          ALL: false,
          KS: false,
          KL: false,
          CTV: false,
        },
        snackbarContent:
          'Đã có lỗi hệ thống xảy ra, vui lòng kiểm tra lại hoặc liên hệ với admin!!!',
        pagination: {
          ascending: true,
          sortBy: 'name',
          rowsPerPage: 10,
          page: 1,
        },
        headers: [
          {
            text: '#',
            sortable: false,
            width: '20px',
            format: v => v && String(v),
          },
          {
            text: 'NỘI DUNG CHI',
            sortable: false,
            align: 'left',
            value: 'noi_dung',
          },
          {
            text: 'SỐ TIỀN',
            sortable: false,
            value: 'so_tien',
            align: 'right',
            format: v => v && Number(v).toFixed(2),
          },
          {
            text: 'NGÀY CHI',
            sortable: false,
            value: 'ngay_chi',
            align: 'right',
            format: v => v && moment(String(v)).format('DD/MM/YYYY hh:mm'),
          },
          {
            text: 'KỲ-NĂM',
            sortable: false,
            value: 'ky_chi',
            align: 'center',
            format: v => v && Number(v).toFixed(2),
          },
          {
            text: 'BANK',
            sortable: false,
            value: 'bank_code',
          },
          {
            text: 'Trạng thái',
            value: 'status_nm',
            align: 'left',
          },
          {
            text: 'Trạng thái',
            value: 'status',
            align: 'center',
          },
          {
            text: 'Còn lại',
            sortable: false,
            align: 'right',
            value: 'balance_in_month',
          },
        ],
        items: [],
        itemBankFilter: [],
        itemDetail: [],
        chiTieuSelected: [],
        lstStatus: [
          {
            id: 'DCHI',
            name: 'Dự Chi',
          },
          {
            id: 'CHM',
            name: 'Cho Mượn',
          },
          {
            id: 'DTT',
            name: 'Đã Tất Toán',
          },
          {
            id: 'DN',
            name: 'Dư Nợ',
          },
          {
            id: 'DTCSK',
            name: 'Đã Trả / CSK',
          },
          {
            id: 'DTN',
            name: 'Đã trả nợ',
          },
          {
            id: 'NHT',
            name: 'Nhận tiền',
          },
          {
            id: 'HTN',
            name: 'Hoàn Tiền',
          },
          {
            id: 'MNT',
            name: 'Mượn Tiền',
          },
          {
            id: 'FAIL',
            name: 'Giao dịch lỗi',
          },
        ],
        lstMucDich: [
          {
            id: 'KD',
            name: 'KINH DOANH',
          },
          {
            id: 'GD',
            name: 'GIA ĐÌNH',
          },
          {
            id: 'CN',
            name: 'CÁ NHÂN',
          },
          {
            id: 'CM',
            name: 'CHO MƯỢN',
          },
          {
            id: 'GDAE',
            name: 'GĐ-ANH EM',
          },
        ],
        stsThanhToan: [
          {
            id: 'DN',
            name: 'Dư nợ',
          },
          {
            id: 'NX',
            name: 'Nợ xấu',
          },
          {
            id: 'CTT',
            name: 'Chờ thanh toán',
          },
          {
            id: 'CSK',
            name: 'Chờ sao kê',
          },
          {
            id: 'FAIL',
            name: 'GD lỗi',
          },
        ],
        lstKyChi: [
          '102020',
          '112020',
          '122020',
          '12021',
          '22021',
          '32021',
          '42021',
          '52021',
          '62021',
          '72021',
          '82021',
          '92021',
          '102021',
          '112021',
          '122021',
        ],

        chitieu: {},
        lstBank: [],
        originListChiTieu: [],
      }
    },
    computed: {
      //   ...bankState("bank", {
      //     bankList: "bankList",
      // })
      totals () {
        let sums = 0
        for (var idx in this.chiTieuList) {
          sums += parseFloat(this.chiTieuList[idx].so_tien)
        }
        return sums
      },
      filteredItems: function () {
        var self = this
        return self.chiTieuList.filter(function (item) {
          return item.indexOf(self.searchQuery) !== -1
        })
      },
     
    }, // end method
    mounted () {
      this.getBanks()
      this.getChiTieus()
    },
    created () {
      this.filterStatus()
      this.getKyTinh('HSBC', new Date(), new Date().getDate())
      this.getKyTinh('SC BANK', new Date(), new Date().getDate())
      this.getKyTinh('CitiBank', new Date(), new Date().getDate())
      console.log('config', config)
      
    },
    methods: {
      isMobile () {
        if (
          /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(
            navigator.userAgent,
          )
        ) {
          return true
        } else {
          return false
        }
      },
      addChiTieu () {
        // this.$router.push({ name: 'CHI TIẾT CHI TIÊU' })
        this.$refs.addChiTieu.chiTieuModel.so_tien = 0
        this.$refs.addChiTieu.chiTieuModel.status = 'DN'
        this.$refs.addChiTieu.chiTieuModel.noi_dung = []
        this.$refs.addChiTieu.chiTieuModel.ghi_chu = ''

        //  this.$refs.addChiTieu.dialog = true
        this.$router.push({ name: 'Thêm chi tiêu' })
      },
      gotoPage (page) {
        this.$router.push({ name: page })
      },
      async getBanks () {
        const seft = this
        await axios
          .get(config.API_FAMILY + '/api/banks')
          .then(function (response) {
            // this.insertChitieuDialog.dialog = false;
            console.log(response.data.data)
            seft.lstBank = response.data.data
          })
      },
      async getChiTieus () {
        const self = this
        console.log('getChiTieus')
        console.log(this.saleOrder)

        var orderType = []
        if (!this.customerTypeModal.ALL) {
          if (this.customerTypeModal.KS) {
            orderType.push("'KS'")
          }
          if (this.customerTypeModal.KL) {
            orderType.push("'KL'")
          }
          if (this.customerTypeModal.CTV) {
            orderType.push("'CTV'")
          }
        } else {
          orderType.push("'KL'")
          orderType.push("'KS'")
          orderType.push("'CTV'")
        }
        console.log(orderType.toString())
        this.saleOrder.order_customer_type = orderType.join()
        await axios
          .get(config.API_FAMILY + '/api/chitieus')
          .then(function (response) {
            // self.chiTieuList = response.data.data
            self.originListChiTieu = response.data.data
            // self.originListChiTieu = self.chiTieuList
            // Dư nọ - chờ sao kê
            self.chiTieuList = self.originListChiTieu.filter(function (item) {
              if (item.status === 'DN') return true
            })

            // Cho Thanh toan
            self.chiTieuList = self.originListChiTieu.filter(function (item) {
              if (item.status === 'DN') return true
            })

            // Du Chi
            self.chiTieuList = self.originListChiTieu.filter(function (item) {
              if (item.status === 'DC') return true
            })

            // Loi
            self.chiTieuList = self.originListChiTieu.filter(function (item) {
              if (item.status === 'ERR') return true
            })

            self.totalChiTieu()
            self.filterStatus()
          // console.log(JSON.stringify(self.chiTieuList))
          })
      },
      confirmDeleteChiTieu (detail) {
        // this.$refs.dialogConfirm.title = 'Xác nhận'
        // this.$refs.dialogConfirm.text = 'Bạn có chắc chắn muốn xóa đơn hàng này không?'
        if (detail != undefined && detail != null) {
          this.chiTieuSelected = detail
        }
        this.$refs.dialogConfirm.dialog = true
      },

      async deleteChiTieu () {
        let itemDelete = this.selected
        if (this.chiTieuSelected != undefined && this.chiTieuSelected != null) {
          itemDelete = this.chiTieuSelected
        }
        console.log('a')
        console.log(itemDelete)
        if (itemDelete !== undefined && itemDelete != null) {
          const seft = this
          const jsonReq = JSON.stringify(itemDelete)

          await axios
            .post(config.API_FAMILY + '/api/deleteChiTieu', JSON.parse(jsonReq))
            .then(function (response) {
              console.log('succuess')
              var data = response.data.data
              if (data !== undefined && data != null) {
              }
              seft.getChiTieus()

              seft.$refs.dialogConfirm.dialog = false
            })
            .catch(error => {
              console.log(error)
            })
        }
      },

      updateSts (obj, type) {
        this.$refs.refUpdateStatus.dialog = true
      // let self = this;
      // console.log("UPDATE STATUS")
      // console.log(this.kyChiSeleted)
      // console.log(this.bankSeleted)

      // console.log("END UPDATE STATUS")
      // if('CSK' == type){
      //   //Chốt sao kê

      //   if (this.bankSeleted != undefined && this.bankSeleted.length > 0
      //       && this.kyChiSeleted != undefined && this.kyChiSeleted.length > 0) {

      //     let reqBank = [];
      //     for (var key in this.bankSeleted) {
      //       reqBank.push(this.bankSeleted[key].name)
      //     }
      //     let params = {
      //       ghi_chu: "",
      //       status: "DTCSK",
      //       bank_code: reqBank ,
      //       ky_chi: this.kyChiSeleted,

      //     }
      //     await axios
      //     .post(config.API_FAMILY + '/api/updateStatusByBank', params)
      //     .then(function (response) {
      //       console.log("succuess")
      //       var data = response.data.data
      //       if (data !== undefined && data != null) {
      //       }
      //       self.getChiTieus()

      //       // seft.$refs.dialogConfirm.dialog = false
      //     }).catch((error) => {
      //       console.log(error)
      //     })
      //   }
      // }
      },
      showTotal () {
        // alert('a')
        this.$refs.chiTieuTotal.dialog = true
      },
      formatPrice (value, tofix) {
        const val = (value / 1).toFixed(tofix).replace(',', '.')
        return val.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ',')
      },
      getKyTinh (sbankObj, sDate, sDay) {
        var kyTinh = ''
        var deltaMonth = 1
        var month = sDate.getMonth()
        var deltaYear = 0
        if (sbankObj != undefined && sbankObj != null) {
          var sBanName = sbankObj.name
          if (
            ((sBanName == 'HSBC' || sBanName == 'SHINHAN') && sDay + 1 >= 21) ||
            (sBanName == 'SC BANK' && sDay + 1 >= 19) ||
            (sBanName == 'CitiBank' && sDay + 1 >= 27)
          ) {
            deltaMonth = 2
          } else {
            deltaMonth = 1
          }

          if (sDate.getMonth() + deltaMonth > 12) {
            deltaYear = 1
            kyTinh = '1' + (sDate.getFullYear() + deltaYear).toString()
          } else {
            kyTinh =
              (month + deltaMonth).toString() +
              (sDate.getFullYear() + deltaYear).toString()
          }
        }
        console.log('year:' + sDate.getFullYear())
        console.log('kyTinh-' + sBanName + ':' + kyTinh)
        return kyTinh
      },
      async onTabChange (clickedTab) {
        await this.$emit('onOrderTab', clickedTab)
        this.currentTab = clickedTab
        await this.$nextTick()
        if (!this.allowTabChange) this.currentTab = this.previousTab
        else this.previousTab = this.currentTab
        // TO GET TAB DATA OF CLICKED AND CURRENT TAB
        this.currentTabObject = this.tabs[this.currentTab]
        this.selectedTabObject = this.tabs[clickedTab]
        // console.log("onTabCHange");
        console.log('clickedTab', clickedTab)
        // this.tabs[3].disabled = !this.validateBiz()
      },
      async totalChiTieu () {
        const self = this
        await axios
          .get(config.API_FAMILY + '/api/totalChiTieu')
          .then(function (response) {
            self.chitieu = response.data.data
            console.log(JSON.stringify(self.chitieu))
          })
      },
      moment: function (date) {
        return moment(date)
      },
      date: function (date) {
        return moment(date).format('MMMM Do YYYY, h:mm:ss a')
      },

      snackbaralert (...args) {
        if (args === undefined || args < 3) {
          this.$refs.snackNotification.color = this.colors[4]
          this.$refs.snackNotification.snackbarContent =
            'Đã có lỗi xảy ra, vui lòng liên hệ admin'
          this.$refs.snackNotification.snackbar = true
        } else {
          this.$refs.snackNotification.color = args[0]
          this.$refs.snackNotification.snackbarContent = args[1]
          this.$refs.snackNotification.snackbar = true
        }
      },
      async filterStatus () {
        console.log('fiter')
        // console.log(filter)
        // console.log('filterArr')
        // console.log(this.filterArr)
        // console.log('kyChiSeleted')
        // console.log(this.kyChiSeleted)
        // console.log('bankSeleted')
        // console.log(this.bankSeleted)
        // console.log('statusSeleted')
        // console.log(this.statusSeleted)

        // if (
        //   (this.bankSeleted == undefined || this.bankSeleted.length == 0) &&
        //   (this.kyChiSeleted == undefined || this.kyChiSeleted == '') &&
        //   (this.statusSeleted == undefined || this.statusSeleted == '')
        // ) {
        //   this.chiTieuList = this.originListChiTieu
        // } else {
        //   const seft = this
        //   var newList = this.originListChiTieu
        //   if (this.bankSeleted != undefined && this.bankSeleted.length > 0) {
        //     newList = newList.filter(function (item) {
        //       // Filter bank
        //       for (var key in seft.bankSeleted) {
        //         if (item.bank_code == seft.bankSeleted[key].name) return true
        //       }
        //       return false
        //     })
        //   }
        //   if (this.kyChiSeleted != undefined && this.kyChiSeleted != '') {
        //     newList = newList.filter(function (item) {
        //       // Filter ky chi
        //       if (item.ky_chi == seft.kyChiSeleted) return true
        //       else return false
        //     })
        //   }

        //   if (this.statusSeleted != undefined && this.statusSeleted.length > 0) {
        //     newList = newList.filter(function (item) {
        //       // Filter trang thai
        //       for (var key in seft.statusSeleted) {
        //         if (item.status == seft.statusSeleted[key].id) return true
        //       }
        //       return false
        //     })
        //   }

        //   this.chiTieuList = newList
        // }
        const seft = this
        var newList = this.originListChiTieu
        // // Condition
        // var idx = this.bankChecked.indexOf(value)
        // if (idx === -1) {
        //   this.bankChecked.push(value)
        // } else {
        //   if (!filter) {
        //     this.bankChecked.splice(idx, 1)
        //   }
        // }

        console.log(this.bankChecked)
        // if (filter && value !== '') {

        // }
        if (this.bankChecked === undefined ||
          this.bankChecked.length === 0) {
          this.getChiTieus()
        } else {
          newList = newList.filter(function (item) {
            // Filter bank
            for (var key in seft.bankChecked) {
              if (item.bank_code === seft.bankChecked[key]) return true
            }
            return false
          })
          this.chiTieuList = newList
        }
        // this.chiTieuList = newList
        // let sums = 0
        // for (var idx in this.chiTieuList) {
        //   sums += parseFloat(this.chiTieuList[idx].so_tien)
        // }
        // this.totals = sums
      },
    },
  }
</script>
<style scroped>
.text-right {
  text-align: right;
}
.text-center {
  text-align: center;
}
table tr td {
  padding: 0 8px !important;
}

.table-list table thead tr th {
  background-color: #2196f3 !important;
  color: #ffffff;
}
/* .table-list table {
  border-collapse: collapse !important;
  border: 1px solid gray !important;
} */
</style>
